# !/usr/bin/python
# coding=utf-8

import os, sys, time,datetime
pythpn_v = sys.version_info < (3, 0)
if pythpn_v:
    import commands
else:
    import subprocess
import argparse

if not os.path.exists("Wangxun_debug_info"):
     os.mkdir("Wangxun_debug_info")
now_time = datetime.datetime.now()
test_time = now_time.strftime('%Y-%m-%d-%H%M')
test_log_file = "./Wangxun_debug_info/wx_log_%s"%test_time
# wxtool = "./wxtool_x86"

parse = argparse.ArgumentParser()
parse.add_argument("-v", "--verbose", help="output ver", action="store_true")
parse.add_argument("-w", "--wxtool", help="wxtool type", default="./wxtool_x86")
parse.add_argument("-J", "--Judge", help="add judge condition", action="store_true")
parse.add_argument("-I", "--Inface", help="add judge inface,example: em1,em2",default = "")
arg = parse.parse_args()
verbose = arg.verbose
wxtool = arg.wxtool
Judge = arg.Judge
Inface = arg.Inface

def send_cmd(cm):
    cm = cm.replace("\n", "")
    print("#"+cm)
    f = open(test_log_file,"a+")
    f.write("\n")
    f.write("#" + cm + "\n")
    f.close()
    if sys.version_info < (3, 0):
        # python2
        status, out = commands.getstatusoutput(cm)
        # logg.debug(out)
        if status != 0:
            # logg.error(out)
            pass
        f = open(test_log_file, "a+")
        f.write(out + "\n")
        f.close()
        if verbose:
            print(out)
        return out
    else:
        # python3
        subp = subprocess.Popen(cm, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE, encoding="utf-8")
        out1 = subp.stdout.read()
        # logg.debug(out1)
        out2 = subp.stderr.read()
        if out2 != "":
            # logg.error(out2)
            # return out2
            print(out2)
            pass
        f = open(test_log_file, "a+")
        f.write(out1 + "\n" + out2 + "\n")
        f.close()
        if verbose:
            print(out1 + "\n" + out2 + "\n")
        return out1

def judge():
    print("begin judging the lan link status in 10S!")
    time.sleep(10)
    if Inface == "":
        pci_out = send_cmd(' lspci -D -d 8088: -nm |cut -s -d  " " -f 1').strip("\n").split("\n")
        print(pci_out)
        for pci_b in pci_out:
            solt = pci_b.split(":")
            lan_na = send_cmd('ls /sys/bus/pci/devices/%s\:%s\:%s/net' % (solt[0], solt[1], solt[2]))
            send_cmd("cat /sys/class/pci_bus/%s\:%s/device/%s\:%s\:%s/numa_node " % (
                solt[0], solt[1], solt[0], solt[1], solt[2]))
            link_out = send_cmd("ethtool  %s" % lan_na)
            if "Link detected: no" in link_out:
                return False
        return True
    else:
        for inf in Inface.strip("\n").split(","):
            link_out = send_cmd("ethtool  %s" % inf)
            if "Link detected: no" in link_out:
                return False
        return True

class wx_nic_info():

    def get_nic_ID(self):

        return send_cmd("lspci -D -d 8088: -nm")

    def get_nic_bus(self):

        return send_cmd(' lspci -D -d 8088: -nm |cut -s -d  " " -f 1').strip("\n").split("\n")

    def get_all_eth(self):

        return send_cmd("lspci |grep Eth")

    def get_all_pci(self):

        send_cmd("lspci")
        send_cmd("lspci -t ")
        send_cmd("lspci -t -v")
        return send_cmd('lspci -D | cut -s -d " " -f 1').strip("\n").split("\n")

    def get_nic_pcie_info(self,pci_bus):

        return send_cmd("lspci -s %s -vvv"%pci_bus)

    def get_nic_lan_name(self,pci_bus):

        solt = pci_bus.split(":")
        lan_name = send_cmd('ls /sys/bus/pci/devices/%s\:%s\:%s/net'%(solt[0],solt[1],solt[2]))
        send_cmd("cat /sys/class/pci_bus/%s\:%s/device/%s\:%s\:%s/numa_node "% (solt[0],solt[1],solt[0],solt[1],solt[2]))

        return lan_name

    def get_nic_version(self,lan_name):

        return send_cmd("ethtool -i %s"%lan_name)

    def get_nic_link(self,lan_name):

        return send_cmd("ethtool  %s" % lan_name)

    def get_cpu_info(self):

        return send_cmd("lscpu")

    def get_kernel_info(self):

        return send_cmd("uname -a")

    def get_os_info(self):

        out = send_cmd("cat /etc/redhat-release ")
        if not os.path.exists("/etc/redhat-release"):
            out = send_cmd("cat /etc/issue")
        return out

    def get_os_log(self,directory):

        send_cmd("cp -r /var/log/messages* %s"%directory)
        send_cmd("cp -r /var/log/syslog* %s" % directory)

    def get_os_ip(self):

        send_cmd("ip a")
        send_cmd("ifconfig -a")
        send_cmd("systemctl status NetworkManager")
        send_cmd("nmcli connection show ")
        send_cmd("history")

    def get_os_route(self):

        send_cmd("route -n")
        send_cmd("route  -n -6")

    def get_os_mem(self):

        send_cmd("lsmem")
        send_cmd("numactl -H")

    def get_nic_wxtool(self,wxtool):

        send_cmd("%s show -i "%wxtool)

    def get_fw_time(self,wxtool,pci_bus):

        send_cmd("%s -s %s -f -r 0x0"%(wxtool,pci_bus))
        send_cmd("%s -s %s -f -r 0xfffd0"%(wxtool,pci_bus))
        send_cmd("%s -s %s -f -r 0xfffd4"%(wxtool,pci_bus))
        send_cmd("%s -s %s -f -r 0xfffd8"%(wxtool,pci_bus))
        send_cmd("%s -s %s -f -r 0xfffdc"%(wxtool,pci_bus))

    def get_nic_ethtool(self,eth):

        send_cmd("ethtool -S %s" % eth)
        send_cmd("ethtool -k %s" % eth)
        send_cmd("ethtool -g %s" % eth)
        send_cmd("ethtool --show-priv-flags %s" % eth)

    def get_irq(self,eth):
        out = send_cmd(" cat /proc/interrupts |grep %s |grep TxRx |awk -F ':' '{print $1}'" % eth).split()
        for i in out:
            send_cmd("cat /proc/irq/%s/smp_affinity_list" % (i))

if __name__ == "__main__":

    print("---------------------------------")
    print("wangxun nic info tool version: 1.0.2.1")
    print("start connecting wangxun nic info:")
    print("---------------------------------")
    print("")
    panduan = False

    if Judge:
        panduan=judge()

    if panduan == False:
        wx = wx_nic_info()
        pci_bus_all = wx.get_nic_bus()
        wx.get_all_eth()
        pci_all_bus = wx.get_all_pci()
        for sl in pci_all_bus:
            wx.get_nic_pcie_info(sl)
        #print(pci_bus_all)
        wx.get_nic_ID()
        eth_name_all = []
        for slot in pci_bus_all:
            wx.get_nic_pcie_info(slot)
            eth_name = wx.get_nic_lan_name(slot)
            eth_name_all.append(eth_name)
            wx.get_nic_version(eth_name)
            wx.get_nic_link(eth_name)
            wx.get_nic_ethtool(eth_name)
            wx.get_irq(eth_name)

        wx.get_kernel_info()
        wx.get_os_info()
        wx.get_cpu_info()
        wx.get_os_ip()
        wx.get_os_route()
        wx.get_os_mem()
        wx.get_os_log("Wangxun_debug_info")

        wx.get_nic_wxtool(wxtool)
        for slot in pci_bus_all:
            wx.get_fw_time(wxtool,slot)

        print("")
        print("---------------------------------")
        print("finished! the info is saved in Wangxun_debug_info folder!")
        print("please open Wangxun_debug_info, and check!")
        print("---------------------------------")
    else:
        print("os will reboot in 5s")
        time.sleep(5)
        send_cmd("reboot")


